Repository navigation
feat(ime): compact live WPM in the keyboard top bar + the RFC 0012 opt-in toggle - #81
Merged
Merged
Conversation
…ct-entry clause (2026-10-30 amendment)
RFC 0012 exempted IME surfaces ('no persistent strip') — the Android
IME now has a stable top bar, so the exemption is lifted by amendment
(governance PR follows). Windows shows the same thing in its Direct
Mode mini-bar.
- Settings → Output → 'Show typing rate' (default OFF per the RFC):
one toggle now governs BOTH surfaces — the main app's status-bar
'X.X cps · N wpm' readout (previously always-on; now opt-in as the
RFC always specified) and the IME's compact 'N wpm' (current rate
only, per the direct-entry clause — no cps/max/avg in the strip).
- The IME readout refreshes at 2 Hz from the engine's rolling window
(dasher_get_wpm) and re-reads the setting every tick — toggling
takes effect without restarting the keyboard. Verified on-emulator:
text present with the toggle on (x556-652 in the top bar), absent
with it off (242-pixel diff, on-side only).
- Telemetry: setting_changed fires on toggle (RFC 0001 amendment).
GTK: its Settings → Output readout exists (2 Hz) but the keyboard-mode
surface shows nothing — separate issue filed there.
Signed-off-by: will wade <willwade@gmail.com>
This file contains hidden or bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Sign up for free
to join this conversation on GitHub.
Already have an account?
Sign in to comment
Add this suggestion to a batch that can be applied as a single commit.This suggestion is invalid because no changes were made to the code.Suggestions cannot be applied while the pull request is closed.Suggestions cannot be applied while viewing a subset of changes.Only one suggestion per line can be applied in a batch.Add this suggestion to a batch that can be applied as a single commit.Applying suggestions on deleted lines is not supported.You must change the existing code in this line in order to create a valid suggestion.Outdated suggestions cannot be applied.This suggestion has been applied or marked resolved.Suggestions cannot be applied from pending reviews.Suggestions cannot be applied on multi-line comments.Suggestions cannot be applied while the pull request is queued to merge.Suggestion cannot be applied right now. Please check back later.
Implements the RFC 0012 direct-entry clause for Android (2026-10-30 amendment, governance PR follows): compact live WPM in the keyboard's top bar, like Windows' Direct Mode mini-bar, plus the RFC's opt-in toggle which Android never had.
X.X cps · N wpmreadout (previously always-on; the RFC always specified opt-in)N wpm(current rate only — no cps/max/avg, per the direct-entry clause)dasher_get_wpm, re-reads the setting every tick (toggle takes effect without restarting the keyboard), starts/stops with the keyboard show/hidesetting_changedtelemetry on toggle (RFC 0001 amendment)Verified on-emulator both directions: text block present in the top bar with the toggle on (x556–652), absent with it off — 242-pixel diff, all on-side; toggle state confirmed in prefs via root.
The RFC's original IME exemption read "no persistent strip; revisit with RFC 0008 flows" — the IME now has a stable top bar, so the amendment lifts it.